using Gep.Api.Util;

namespace Gep.Api.Demo
{
    /// <summary>
    /// 兑换分发API示例
    /// </summary>
    public class Exchange
    { 
        /// <summary>
        /// 文件上传
        /// </summary>
        public static void UploadFile()
        {
            string path = "/api/common/file/upload-file";
            string filePath = StringUtil.GetCurrentPath()+"\\Cert\\test.jpg";
            FileItem fileItem = new FileItem(filePath);
            Dictionary<string, FileItem> fileItemDict = new()
            {
                { "file", fileItem }
            };
            
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "userNo", "5181240322000274308" },
                { "fileName", fileItem.GetFileName() },
                { "fileMd5encryption", fileItem.GetFileMD5() },
                { "fileType", "2" }
            };
            ApiRequest.AgentPost(path, dataContent, fileItemDict);
        }
        /// <summary>
        /// 账户余额查询
        /// </summary>
        public static void QueryUserBalanceAccount()
        {
            string path = "/api/user/account/queryUserBalanceAccount";
            
            Dictionary<string, string> dataContent = new Dictionary<string, string>
            {
                { "userNo", "5181240322000274308" },
                { "ccy", "CNH" }
            };
            ApiRequest.AgentPost(path, dataContent);
        }
    }
}