using System.Text.Json;
using Gep.Api.Model;

namespace Gep.Api.Util
{
    public class ApiRequest
    {
        private static readonly HttpUtils httpUtils = new HttpUtils();
        public static string AgentPost(string path, Dictionary<string, string> dataContent, Dictionary<string, FileItem> file = null,bool needDecrypt=true)
        {
            string url = ConfigUtil.ServerUrl + path;
            Console.WriteLine("请求地址：" + url);
            string dataContentJson = JsonSerializer.Serialize(dataContent);
            Console.WriteLine("dataContent 明文信息：" + dataContentJson);
            string ciphertext = RSAUtil.EncryptRSAByPfx(dataContentJson, ConfigUtil.PfxPath, ConfigUtil.PfxPwd);
            Console.WriteLine("dataContent 密文信息：" + ciphertext);
            
            Dictionary<string, string> parameters = new Dictionary<string, string>();
            parameters.Add("version", ConfigUtil.Version);
            parameters.Add("certificateId", ConfigUtil.CertificateId);
            parameters.Add("agentNo", ConfigUtil.AgentNo);
            parameters.Add("dataType", ConfigUtil.DataType);
            parameters.Add("apiType", ConfigUtil.ApiType);
            if (dataContent.TryGetValue("userNo", out string value))
            {
               parameters.Add("userNo", value);
            }
            parameters.Add("dataContent", ciphertext);
            
            Console.WriteLine("请求参数：" + JsonSerializer.Serialize(parameters));
            
            // 设置请求超时时间
            httpUtils.Timeout = 30000; // 30秒
            string charset = "UTF-8"; // 设置字符集
            string response = httpUtils.DoPost(url, parameters, file, charset);
            Console.WriteLine("响应结果：" + response);
            GepResponse gepResponse = JsonSerializer.Deserialize<GepResponse>(response);
            if (gepResponse.success){
                Console.WriteLine("=== 受理成功-业务处理逻辑 ===");
                //TODO: 受理成功，业务处理逻辑
                if (needDecrypt)
                {
                    string decrypt = RSAUtil.DecryptRSAByCer(gepResponse.result, ConfigUtil.CerPath);
                    Console.WriteLine("result 结果解密：" + decrypt);
                    gepResponse.result = decrypt;
                }
            }else
            {
                Console.WriteLine("=== 受理失败-业务处理逻辑 ===");
                //TODO: 受理失败，业务处理逻辑
            }

            return JsonSerializer.Serialize(gepResponse);
        }
    }
}